# -*- coding: utf-8 -*-
"""
Copyright © 2017 SDElements Inc.

This application/module/plugin functions as a certmonger helper and a certbot
plugin. The operation depends on the entry point.

TBD Explain different entry points and flows

https://pagure.io/certmonger/blob/master/f/doc/helpers.txt
Add documentation for certbot plugins
"""

import hashlib
import logging
import os
import sys
import cerlet.certmonger

from .installer import Installer
from .authenticator import Authenticator

__version__ = '0.0.6'

# Set up logging
logger = logging.getLogger('cerlet')


def main():
    """ Entry point when run directly """
    env = cerlet.certmonger.CertMongerAction.load_environment_variables()
    if env:
        sys.exit(cerlet.certmonger.CertMongerAction.operation_factory(os.getenv('CERTMONGER_OPERATION')))
    from pkg_resources import load_entry_point
    sys.argv += ['--authenticator', 'ipa']
    sys.exit(load_entry_point('certbot', 'console_scripts', 'certbot')())
